/*
  Copyright 2010, 2010 STARWest

  See the file STARWest.txt for details about the STARWest research group

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Héliostat à facette plane sur structure sphérique 


// H1.cpp*
#include "shape.h"
#include "dynload.h"
// H1 Declarations
class H1: public Shape {
public:
	// H1 Public Methods
	H1(const Transform &o2w, bool ro, float RayCourbe);
	BBox ObjectBound() const;
	bool CanIntersect() const { return false; }
	void Refine(vector<Reference<Shape> > &refined) const;
	
private:
	// H1 Private Data
	float RayCourbe;
        
};
// H1 Method Definitions
H1::H1(const Transform &o2w, bool ro, float R)
	: Shape(o2w, ro) {
	RayCourbe = R;
	
}
BBox H1::ObjectBound() const {
  return BBox(Point(-5,-5,5),Point(5,5,5));
}
void H1::Refine(vector<Reference<Shape> > &refined) const {
  ParamSet paramset;
  float x,y,z,c=0.99;
  Transform F2H;
  //std::cout<<RayCourbe<<std::endl;
 
  paramset.AddFloat("cote", &c, 1);
 
   for (x=-4.5; x<5; x=x+1){
     for(y=-4.5; y<5; y=y+1){
      z=RayCourbe-sqrt(RayCourbe*RayCourbe-x*x-y*y);
      F2H=LookAt(Point(x,y,z),Point(0,0,RayCourbe),Vector(0,-1,0)).GetInverse();
      refined.push_back(MakeShape("H1F1",ObjectToWorld*F2H, reverseOrientation, paramset));
 	}
   }
}
extern "C" DLLEXPORT
	Shape *CreateShape(const Transform &o2w,
					   bool reverseOrientation,
					   const ParamSet &params) {
	float RayCourbe = params.FindOneFloat("Rcourbe", 1000.f);
	return new H1(o2w, reverseOrientation, RayCourbe);
}






/////////////  Conseil Anthony
/* 
 paramset.AddFloat("radius", &radius1, 1);
  Reference<Shape> s = MakeShape("sphere",ObjectToWorld, reverseOrientation, paramset);
  refined.push_back(s);
  listeHelio.push_back (s);
*/

